//! Rust interface for Event handlers (`GHOST_TEventType` et. al)
use super::*;

pub enum CursorEventType
{
    Move,
    ButtonDown,
    ButtonUp,
    Wheel,
    Trackpad,
}

pub enum KeyboardEventType
{
    KeyUp,
    KeyDown,
    // Auto,
}

pub enum WindowEventType
{
    Close,
    Activate,
    Deactivate,
    Update,
    Size,
    Move,
    DPIHintChanged,
}

pub enum DragEventType
{
    Entered,
    Updated,
    Exited,
    DropDone,
}

pub enum ImeCompositionEventType
{
    Composition,
    Start,
    End,
}

pub enum EventType
{
    Cursor(CursorEventType),
    Keyboard(KeyboardEventType),

    QuitRequest,
    Window(WindowEventType),

    Drag(DragEventType),

    OpenMainFile,
    NativeResolutionChange,

    Timer,

    ImeComposition(ImeCompositionEventType),
}
